
/*
Christof Ermer
Regensburg
ChristofErmer@gmail.com
03.06.201
*/


/* HYSTORY
Befehle: Viele  CheckOrder() Druckausgaben produziert Neustart
Grund ??  Lsung:	Auslagerung in Main via Flags.
strtok_r  raus --> strtok rein
*/

/* 
BEFEHLE 
Befelsform:
Kommando,u16Val-1,u16Val-2<13>  <13>  //<13> = CR = \r = 13
Bsp:
Motor,123,34<CR>
Ping<CR>
GetSW>CR>

Diese Datei dient zum einfachen Auffinden und Zufgen der Befehle.
Deshalb wurden die Befehle in diese Datei ausgelagert.
1 Newton = ~100g
Gewichtskraft

*/


#include <avr\sfr_defs.h>
#include <avr\io.h>
#include <avr\interrupt.h>
#include <avr\wdt.h>
#include <util\delay.h>
#include <avr\pgmspace.h>
#include <stdint.h> 
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#include <string.h>


#include "main.h"
#include "uart328_16.h"
#include "ParseRx.h"
#include "Befehle.h"
#include "debug.h"
//#include "Braille.h"

//	\r\n return, line fedd
//	\r\n \t  return, line fedd, tabulator

//Prototype
// GLOBALE VARIABLEN
// CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
// const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };


#ifdef UART_USE_ENABLED

// GLOBALE VARIABLEN
COMMAND_TYPE gsCmd;

char gcaTriggerCmdStr[ COMMAND_SIZEMAX + 1]; // "@@@\0"
char *gpcCmdStrPars;

char gcaStr[STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0

uint8_t gu8BefehlStatus;

// PROTO
// **************************
void CMD_StringReset(void)
// **************************
{
*gcaTriggerCmdStr=0;
gpcCmdStrPars = gcaTriggerCmdStr;
};

//Funktionen Definition
// *******************************************************************
void SammeleCMDString(char cRx)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bitmask) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
if( gu8BefehlStatus & BEFEHL_SEQUENCE_LOCKED )
	{
	if( strlen(gcaTriggerCmdStr) < COMMAND_SIZEMAX)	//ENDANSCHLAG ERREICHT ?
		{
		switch( cRx)
			{
			case 10: // LF raus=nix machen
				{				
				break;
				};	           				
			case 13: ////Check CR order
				{
				CheckOrder( gcaTriggerCmdStr ); 
				CMD_StringReset();			
				uart_flush();
				gu8BefehlStatus &= ~BEFEHL_CLEAR_MASK;
				break;
				};	           				
			default: //Accumulate
				{
	  // Accumulate String only to gcaRxStr with  Parser
				if(cRx > 32) // =SPACE  plausibel ASCII
					{
					*gpcCmdStrPars++ = cRx;//Append rxByte
					*gpcCmdStrPars=0;  //ZERO carry
					};			
				};
			};//switch
		}
	else  // To much data Rx, than clear simple all
		{//overflow of RX clears all
		CMD_StringReset();
		};
	}; //BEFEHL_SEQUENCE_LOCKED
// ENDE DER RX EMPFANGSAUSWERTUNG
};

/* Diese Funktion zerlegt den Befehls-String in einzelne Module */
// *******************************************************************
void TokensRXStr(char *pcStrOrder)
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
const char  caDelimiter[]= ",";
char * pStrTok; // fr strtok_r
//char * pcCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*
//char * 	strtok_r (char *, const char *, char **)
//char * 	strtok (char *, const char *)
//if( (pStrTok = strtok_r( pcStrOrder, caDelimiter , &pcCh)) != NULL) // Trenne 1.Token in Command
if( (pStrTok = strtok( pcStrOrder, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{	
	strcpy(gsCmd.caCmd, pStrTok);
	}
else
	{
	*gsCmd.caCmd = 0;
	};
gsCmd.caCmd[ COMMAND_SIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

//fr 2 fVal Variablen nach dem Kommand
gsCmd.i16CmdVal_1 = 0;
gsCmd.i16CmdVal_2 = 0;
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
	//gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_1 = atoi(pStrTok);
	};
//HIER NULL POINTER
if( (pStrTok = strtok( NULL, caDelimiter)) != NULL) // Trenne 1.Token in Command
	{
//	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	gsCmd.i16CmdVal_2 = atoi(pStrTok);
	};	
};


// *********************************
void CheckOrder(char *pcStrOrder) //von gcaRxRingBuf
// *********************************
{ //Input von der Seriellen Schnittstlle, in der Form:  "BEFEHL,WERT" BSP: "SFR,1000"
//========================
TokensRXStr(pcStrOrder);
//========================
if( !strcasecmp_P( gsCmd.caCmd, PSTR("PING") )  )
	{	
	uart_puts_p( PSTR("PONG\r") );	
	return;
	};
	
if(!strcasecmp_P( gsCmd.caCmd, PSTR("DEVICE")))  // GET
	{
	uart_puts_p( PSTR("UNO-R3 BRAILLE\r") );
	return;
	};

if(!strcasecmp_P( gsCmd.caCmd, PSTR("TT"))) //TICKS anzeigen
	{
	uart_puts( ultoa( gu32_Ticks, gcaStr, 10 ) );
	uart_putc( 13 ); //CR
	return;
	}	

/*
if(!strcasecmp_P( gsCmd.caCmd, PSTR("")))
	{
	return;
	};
*/	
 }; // ORDER
 
#endif //UART_USE_ENABLED
