

/*
Christof Ermer
Regensburg
ChristofErmer@gmail.com
12.07.2018
*/

#include <avr\sfr_defs.h>
#include <avr\io.h>
#include <avr\wdt.h>
#include <avr\pgmspace.h>
#include <stdlib.h>
#include <string.h>

#include "main.h"
#include "debug.h"
#include "uart328_16.h"
#include "Befehle.h"
#include "RingBuf.h"
#include "ParseRx.h"
#include "Braille.h"


#ifdef UART_USE_ENABLED


// auf Braille Codeset reduziert RINGBUF_TYPE;


RINGBUF_TYPE gsCodeSetStrBuf;
uint8_t gu8aCodeSetStr[ PARSE_RINGBUFF_SIZE ];  // INSTANZ DES BUFFERS

uint8_t gu8Analyse_Flags=0;
uint8_t gu8RxParse_State_Flags;
// *** Prototype  ***
void CheckRxContent(uint8_t u8RxC); //CMD ODER BRAILLE ? UART
void ScanRxASCII_ToBrailleContent( uint8_t u8Char);  // vergleiche mit BRAILLE Char set


// ********************************
void ResetCodeSet(void)
// ********************************
{
RingBuf_Flush( &gsCodeSetStrBuf );
gu8Analyse_Flags=0;
gu8RxParse_State_Flags=0;
};

// RING BUIFFER SECTTION
// ********************************
void UART_RX_Check(void) // Fetch all from Uart to RX Ringbuf
// ********************************
{	
uint16_t uiRxUart;
// LOOP UART RX --> Ring
//!FETCH ALLWAYS BYTE FROM UART RX_RINGBUFF INTERRUPT! to Local RX RINGBUF
wdt_reset();

if( !uart_available() )
	{
	return; //Nix da 0xFF
	};
///Weil was da !!
/*
if( (uiRxUart = uart_getc()) & UART_NO_DATA )
	{
	return; //Nix da 0xFF
	};
*/
if(	RingBuf_Check_Overload( &gsCodeSetStrBuf ) == RING_OVL ) 
	{
	gu8RxParse_State_Flags |= RX_PARSE_OVL;	//!!BUF OVL
//Nur Jetzt
//RingBuf_Flush( &gsCodeSetStrBuf );
	uart_puts_p( PSTR("\n\r RingBufOVL \n\r") );
	return;
	}
else
	{
	gu8RxParse_State_Flags &= ~RX_PARSE_OVL;	 // Kein Buf OVL
	};

uiRxUart = uart_getc();
//uart_puts_p( PSTR("\n\r RX:") );
//uart_putc( uiRxUart & 0xFF ); 
//uart_puts_p( PSTR("\n\r") );

//  * check for Frame or Overrun errorif ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
#ifdef USE_ERROR_MSG
	if( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
	{ // Versuche Fehlerbeseituigung
	uart_flush();
	CMD_StringReset();
	uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );a
	uart_puts_p( PSTR("\n\rUartErr\n\r") );
	return;
	};
#endif
//RX Gltig --> verarbeiten	
uiRxUart &= 0xFF;

if( gu8BefehlStatus & BEFEHL_SEQUENCE_LOCKED )
	{	
	SammeleCMDString( (char)uiRxUart );
	return;
	};

//Kein Befehl, dann weiter.	
CheckRxContent( (char)uiRxUart);	
};


// ************************************
void CheckRxContent(uint8_t u8RxC)
// ************************************
{
switch(u8RxC)
	{
//prfe zuerst Sonderzeichen
	case BEFEHL_ID_CHAR:	 //'@'	
		{
		if( !(gu8BefehlStatus & BEFEHL_1_FOUND) )
			{
			gu8BefehlStatus |= BEFEHL_1_FOUND;
			gcaTriggerCmdStr[0]= BEFEHL_ID_CHAR;
			gcaTriggerCmdStr[1]= 0;
			return;
			};
		if( (gu8BefehlStatus & BEFEHL_1_FOUND) &&
			!(gu8BefehlStatus & BEFEHL_2_FOUND)
		
		)
			{
			gu8BefehlStatus |= BEFEHL_2_FOUND;
			gcaTriggerCmdStr[1]= BEFEHL_ID_CHAR;
			gcaTriggerCmdStr[2]= 0;
			return;
			};	
			
		if( (gu8BefehlStatus & BEFEHL_1_FOUND) &&
			(gu8BefehlStatus & BEFEHL_2_FOUND) &&
			!(gu8BefehlStatus & BEFEHL_3_FOUND)
		
		)
			{		
			gu8BefehlStatus |= BEFEHL_3_FOUND | BEFEHL_SEQUENCE_LOCKED;
			gcaTriggerCmdStr[2]= BEFEHL_ID_CHAR;
			gcaTriggerCmdStr[3]= 0;
			return;
			};	
				
		};//BEFEHL_ID_CHAR
		
	default:		
		{
//Ab jezt alle restlichen Zeichen
		ScanRxASCII_ToBrailleContent(u8RxC);
		break;
		};
	
	};//Switch				
};



/*
// +++++++++++++++++++++++++++++++++
//ASCII
char KleinzuGross( char u8Char )
// +++++++++++++++++++++++++++++++++
{
if( (u8Char >= ASCII_a) && (u8Char <= ASCII_z) ) //a..z
	{	//97-65=32
//uart_puts_p( PSTR("\rRX war klein") );
	return u8Char - ABSTAND_GROSS_ZU_KLEIN; // Abstand a--A
	};
return u8Char;
};
*/


// +++++++++++++++++++++++++++++++++
//ASCII
char GrosszuKlein( char u8Char )
// +++++++++++++++++++++++++++++++++
{
if( (u8Char >= ASCII_A) && (u8Char <= ASCII_Z) ) //a..z
	{	//97-65=32
//uart_puts_p( PSTR("\rRX war klein") );
	return u8Char + ABSTAND_GROSS_ZU_KLEIN; // Abstand a--A
	};
//SIEHE 	

return u8Char;
};



// ************************************
void AddRxToCodeSetStr(uint8_t u8RxC)
// ************************************
{	

if( RingBuf_Check_Overload( &gsCodeSetStrBuf) != RING_OVL )
	{
	RingBuf_WriteC(&gsCodeSetStrBuf, u8RxC );
	gu8RxParse_State_Flags &= ~RX_PARSE_OVL;
	return;
	}
else
	{
	uart_puts_p( PSTR("\n\r  AddRxToCodeSetStr OVL\n\r") );
	gu8RxParse_State_Flags |= RX_PARSE_OVL;
	};	
return;
};


// +++++++++++++++++++++++++++++++++
//VORHER !!! prfen ob Platz ist im Ringbuf
// ASCII
void ScanRxASCII_ToBrailleContent(uint8_t u8Char )  // vergleiche mit BRAILLE Char set
// +++++++++++++++++++++++++++++++++
{
// PRFE ZUERST SIONDERZEICHEN
switch(u8Char)
	{		
/*
return;SInglezeichen fr "KRZEL"
u 	au	eu	ei	ie	ch	sch	st	>>	<<

Methode:
1. Registriren
2, Dann Suche nach passenden CHar, Wenn es Treffer gibt ->copy Sonderzeichen
Wenn was anderes kommt, Sende gespeichertes Zeichenflag, wie "A" oder E oder sc 
oder WEnN  kein HIT, dann weiterleiten A..Z
*/
//1. TEIl der Analyse


	case '' : 
	case '' : 
		{
		if( !(gu8Analyse_Flags) ) //
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_AE;
			return;
			};
		break;
		};
		
	case 'a' : 
	case 'A' : 
		{
		if( !(gu8Analyse_Flags) )
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_A;
			return;
			}		
		break;
		};

	case 'e' :
	case 'E' : 
		{
		if( !(gu8Analyse_Flags) )
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_E;
			return;
			}		
		break;
		};

	case 'i' : 
	case 'I' : 
		{
		if( !(gu8Analyse_Flags) )
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_I;
			return;
			}		
		break;
		};

	case 'c' : 	//An 1. & 2. Stelle
	case 'C' : 
		{
		if( !(gu8Analyse_Flags) )	//KANN SCH
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_C;
			return;
			};
		break;
		};
	
	case 's' : 
	case 'S' : 
		{
		if( !(gu8Analyse_Flags) )
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_S;
			return;
			}		
		break;
		};
	}; //Switch
	
// 2. - TEIL DER ANALYSE 2 Tes zeichen suchen
// if ? if( gu8Analyse_Flags |= ANALYSE_EVENT_C	)
switch(u8Char)
	{
	case 'u' : 
	case 'U' : 
		{
		if( gu8Analyse_Flags & ANALYSE_EVENT_AE ) //
			{
			AddRxToCodeSetStr(180);	//U
			gu8Analyse_Flags = 0;
			return;
			};
		if( gu8Analyse_Flags & ANALYSE_EVENT_A ) //a
			{
			AddRxToCodeSetStr(181);	//au
			gu8Analyse_Flags = 0;
			return;
			};		
		if( gu8Analyse_Flags & ANALYSE_EVENT_E ) //eu
			{
			AddRxToCodeSetStr(182);	//eu
			gu8Analyse_Flags = 0;
			return;		
			};		
		break;
		};		

	case 'e' : 
	case 'E' : 
		{
		if( gu8Analyse_Flags & ANALYSE_EVENT_I )//ie
			{
			AddRxToCodeSetStr(184); //ie
			gu8Analyse_Flags = 0;
			return;
			};	
		break;
		};	

	case 'i' : 
	case 'I' : 
		{
		if( gu8Analyse_Flags & ANALYSE_EVENT_E ) //ei
			{
			AddRxToCodeSetStr(183); //ei
			gu8Analyse_Flags = 0;
			return;
			};
		break;
		};	

	case 'h' : 
	case 'H' : 
		{
		if( gu8Analyse_Flags & ANALYSE_EVENT_C ) //ch
			{
			AddRxToCodeSetStr(185); //CH
			gu8Analyse_Flags = 0;
			return;
			};		
		if( gu8Analyse_Flags & ANALYSE_EVENT_SC ) //ch
			{
			AddRxToCodeSetStr(186); //SCH
			gu8Analyse_Flags = 0;
			return;
			};	
		break;
		};
			
	case 'c' : 
	case 'C' :
		{
		if( gu8Analyse_Flags & ANALYSE_EVENT_S ) //SCH
			{
			gu8Analyse_Flags |= ANALYSE_EVENT_SC;//SC--SCH
			return;
			};	
		break;
		};
		
	case 't' : 
	case 'T' : 
		{
		if( gu8Analyse_Flags & ANALYSE_EVENT_S ) //ST
			{
			AddRxToCodeSetStr(187);	//ST
			gu8Analyse_Flags = 0;
			return;
			};
		break;
		};
	}; // "2.ter Switch 
	
//hier komme ich nur her wenn die Returns "NICHT" ausgelst werden
// 3- TEIL DER ANALYSE, wenn bedingungen nic t erfllt Restauriere Zeichen ! auf Flagspeicher
	if( gu8Analyse_Flags & ANALYSE_EVENT_AE ){AddRxToCodeSetStr('');gu8Analyse_Flags = 0;};
	if( gu8Analyse_Flags & ANALYSE_EVENT_A ){AddRxToCodeSetStr('a');gu8Analyse_Flags = 0;};
	if( gu8Analyse_Flags & ANALYSE_EVENT_E ){AddRxToCodeSetStr('e');gu8Analyse_Flags = 0;};
	if( gu8Analyse_Flags & ANALYSE_EVENT_I ){AddRxToCodeSetStr('i');gu8Analyse_Flags = 0;};
	if( gu8Analyse_Flags & ANALYSE_EVENT_S ){AddRxToCodeSetStr('s');gu8Analyse_Flags = 0;};
	if( gu8Analyse_Flags & ANALYSE_EVENT_C ){AddRxToCodeSetStr('c');gu8Analyse_Flags = 0;};
	if( gu8Analyse_Flags & ANALYSE_EVENT_SC )
		{
		AddRxToCodeSetStr('s');
		AddRxToCodeSetStr('c');
		gu8Analyse_Flags = 0;		
		};
		
// Der Rest sollte durchflutschen 
switch(u8Char)
	{	
	case '' : {AddRxToCodeSetStr(CHARCODE_ae_);return;};	//gross 
	case '' : {AddRxToCodeSetStr(CHARCODE_AE_);return;}; //klein
	case '' : {AddRxToCodeSetStr(CHARCODE_oe_);return;}; //klein
	case '' : {AddRxToCodeSetStr(CHARCODE_OE_);return;};	//gross 
	case '' : {AddRxToCodeSetStr(CHARCODE_ue_);return;}; 
	case '' : {AddRxToCodeSetStr(CHARCODE_UE_);return;}; 
	case '' : {AddRxToCodeSetStr(CHARCODE_SH_S_);return;}; 
	
	// 3 Doppelbelegungen
	case 32  : {AddRxToCodeSetStr(u8Char);return;}; //SPACE 
	case 13  : {AddRxToCodeSetStr(u8Char);return;}; //RETURN
	case 10  : {AddRxToCodeSetStr(u8Char);return;}; //LineFeed
	case '.' : {AddRxToCodeSetStr(u8Char);return;}; 
	case ',' : {AddRxToCodeSetStr(u8Char);return;}; 
	case ';' : {AddRxToCodeSetStr(u8Char);return;}; 
	case '!' : {AddRxToCodeSetStr(u8Char);return;}; 
	case '?' : {AddRxToCodeSetStr(u8Char);return;}; 
	case ':' : {AddRxToCodeSetStr(u8Char);return;}; 
	case '"' : {AddRxToCodeSetStr(u8Char);return;};
	case '=' : {AddRxToCodeSetStr(u8Char);return;};
	case '+' : {AddRxToCodeSetStr(u8Char);return;}; //'+* und '!'
	case '-' : {AddRxToCodeSetStr(u8Char);return;};	//minus
	case '*' : {AddRxToCodeSetStr(u8Char);return;};
	case '/' : {AddRxToCodeSetStr(u8Char);return;};
	case '&' : {AddRxToCodeSetStr(u8Char);return;};
	case '(' : {AddRxToCodeSetStr(u8Char);return;};
	case ')' : {AddRxToCodeSetStr(u8Char);return;};	
	case '%' : {AddRxToCodeSetStr(u8Char);return;};
	case '_' : {AddRxToCodeSetStr(u8Char);return;};
	case '>' : {AddRxToCodeSetStr(u8Char);return;};
	case '<' : {AddRxToCodeSetStr(u8Char);return;};
	case '$' : {AddRxToCodeSetStr(u8Char);return;};
	case '[' : {AddRxToCodeSetStr(u8Char);return;};
	case ']' : {AddRxToCodeSetStr(u8Char);return;};
	case '#' : {AddRxToCodeSetStr(u8Char);return;};
	case '^' : {AddRxToCodeSetStr(u8Char);return;};
	case '~' : {AddRxToCodeSetStr(u8Char);return;};	
// PRFE JETZT OB ZEICHEN ZU BEFEHL gehren		
	}; //Case


//BRAILLE_NUMBER_MODE ?
if( (u8Char >= ASCII_0) && (u8Char <=  ASCII_9) ) 
	{
	if( !(gu8BrailleStatus_Flags & BRAILLE_NUMBER_MODE) )
		{
		gu8BrailleStatus_Flags |= BRAILLE_NUMBER_MODE;
		AddRxToCodeSetStr('#'); //Tx 1* '#'
		};
	AddRxToCodeSetStr(u8Char);
	return;
	}
else // Etwas anderes AAls Nummer gefunden
	{
	gu8BrailleStatus_Flags &= ~BRAILLE_NUMBER_MODE; // Immer Raus wenn nicht 0--9
	};		
		
//Unsinnge Low ASCII weg
if( u8Char < 32 ) //SPACE
	{	
	return;
	};

//Goss-->Klein
if( (u8Char >= 'A') && (u8Char <= ASCII_Z) ) 
	{
	AddRxToCodeSetStr( GrosszuKlein(u8Char) );
	return;
	};

if( (u8Char >= ASCII_a) && (u8Char <= ASCII_z) ) 
	{
	AddRxToCodeSetStr(u8Char);
	return;
	};

return;
};


#endif //UART_USE_ENABLED
