

/*
Christof Ermer
Regensburg
ChristofErmer@gmail.com
12.07.2018
*/

#ifndef PARS_RX_H
	#define PARS_RX_H
	
#ifdef UART_USE_ENABLED

#define PARSE_RINGBUFF_SIZE	1024

//FLAGS
#define UART_OK			0x00
#define UART_NIX_DA		0xFF
#define UART_ERROR		0xA5


#define ASCII_A	'A'
#define ASCII_Z	'Z'
#define ASCII_a	'a'
#define ASCII_z	'z'
#define ASCII_0	48
#define ASCII_9	57

#define ABSTAND_GROSS_ZU_KLEIN 32
#define SPACE	' '
#define NUMBERCROSS	'#'
#define BEFEHL_ID	'@'

/*
	case 180 :  return 0x0C;	//"u"
	case 181 :  return 0x21;	//"au"
	case 182 :  return 0x2E;	//"eu"
	case 183 :  return 0x29;	//"ei"
	case 184 :  return 0x2C;	//"ie"	
	case 185 :  return 0x39;	//"ch"
	case 186 :  return 0x21;	//"sch"
	case 187 :  return 0x3E;	//"st" und ']'
	case 190 :  return 0x36; // '='   und "()"	
	case 191 :  return 0x26;	//">>"	
	case 192 :  return 0x34;	//"<<"	
Real gemessen
*/

//http://www.ltg.ed.ac.uk/~richard/utf-8.cgi?input=-&mode=char
	#define PUR_ASCII_CODE_USED
#ifdef PUR_ASCII_CODE_USED
//https://theasciicode.com.ar/extended-ascii-code/letter-a-umlaut-diaeresis-a-umlaut-lowercase-ascii-code-132.html
//https://www.lsa.umich.edu/german/hmr/schreiben/umlaute/umlaute_ASCII_html.html
/*
Character	i.e....	ASCII Code	html Code
small sharp s ("s-zet") 		alt + 225	&szlig;
small  a umlaut	 	alt + 132	&auml; 
small o umlaut		alt + 148	&ouml;
small u umlaut 		alt + 129	&uuml; 
capital A umlaut		alt + 142	&Auml;
capital O umlaut		alt + 153	&Ouml;
capital U umlaut 		alt + 154	&Uuml;
*/
//ONLY CODES > 127 GERMAN
#define ASCCI_ae_	132	//
#define ASCCI_AE_	142	//
#define ASCCI_oe_	148 //
#define ASCCI_OE_	153	//
#define ASCCI_ue_	129	//
#define ASCCI_UE_	154	//
#define ASCCI_SH_S_	225	//

#define CHARCODE_ae_ ASCCI_ae_
#define CHARCODE_AE_ ASCCI_AE_
#define CHARCODE_oe_ ASCCI_oe_
#define CHARCODE_OE_ ASCCI_OE_
#define CHARCODE_ue_ ASCCI_ue_
#define CHARCODE_UE_ ASCCI_UE_
#define CHARCODE_SH_S_	ASCCI_SH_S_
#elif  //UTF-8
/*
UTF-8
=252c   	NICHT ASCII =129
https://wiki.selfhtml.org/wiki/Referenz:HTML/Zeichenreferenz#Unicode-Tabellen
*/
#define UTF_8_ae_ 228	// 
#define UTF_8_AE_ 196	//
#define UTF_8_oe_ 246	// 
#define UTF_8_OE_ 214	//
#define UTF_8_ue_ 228	// 
#define UTF_8_UE_ 252	// 
#define UTF_8_SH_S_ 223	//

#define CHARCODE_ae_ UTF_8_ae_ 
#define CHARCODE_AE_ UTF_8_AE_
#define CHARCODE_oe_ UTF_8_oe_
#define CHARCODE_OE_ UTF_8_OE_
#define CHARCODE_ue_ UTF_8_ue_
#define CHARCODE_UE_ UTF_8_UE_
#define CHARCODE_SH_S_ UTF_8_SH_S_
#endif  //PUR_ASCII_CODE_USED


#define ANALYSE_EVENT_AE		0x01 //U
#define ANALYSE_EVENT_A			0x02
#define ANALYSE_EVENT_E			0x04
#define ANALYSE_EVENT_I			0x08
#define ANALYSE_EVENT_S	 		0x10
#define ANALYSE_EVENT_C			0x20
#define ANALYSE_EVENT_SC		0x40
//#define ANALYSE_EVENT_DBL_PFEIL	0x80
//NUTze unmgliche Komb > & I z.B.
//gu8Analyse_Flags

#define RX_PARSE_OVL	0x01
//gu8RxParse_State_Flags

//Globals

extern RINGBUF_TYPE gsCodeSetStrBuf; //STRUKTUR
extern uint8_t gu8aCodeSetStr[];// INSTANZ DES BUFFERS

extern uint8_t gu8Analyse_Flags;
extern uint8_t gu8RxParse_State_Flags;

//PROTOTYPEN
extern void ClearUART_RxBuf(void);
extern void ResetCodeSet(void);
extern void UART_RX_Check(void);
// -------------------------------------------
//WIEDER RAUS


#endif //#ifdef UART_USE_ENABLED
#endif //#ifndef PARS_RX_H