



#include <avr/sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <stdlib.h>
#include <string.h>
#include <avr/pgmspace.h> // <--#include <progmem.h>
#include "main.h"
#include "debug.h"
#include "uart328_16.h"
#include "RingBuf.h"
#include "Befehle.h"
#include "ParseRx.h"
#include "Braille.h"
#include "PrintInterface.h"
#include "Sprachdefinition.h"

uint8_t gu8PrinterStatus_Flags;
uint8_t gu8Printer_Event_Flags;
uint8_t gu8WriteHeadPos;
uint8_t gu8LineCnt;
uint8_t gu8ActualPrinterBrailleChar;



// ************************************
void Aktion_Wait_ToPaperChange(void)
// ************************************
{
gu8LineCnt = 0;
GOWritehead_Pos(0);
gu8PrinterStatus_Flags |= (PAPERLINES_FULL | Printer_STOP);
uart_puts_p( PSTR( MSG_AKTION_WAIT_TO_PAPER_CHANGE ) );	
uart_puts_p( PSTR( MSG_PLEASE_CONFIRME ) );	
};



// ************************************
void Aktion_PaperChanged(void)
// ************************************
{
gu8LineCnt = 0;
GOWritehead_Pos(0);
gu8PrinterStatus_Flags &= ~(PAPERLINES_FULL | Printer_STOP);
uart_puts_p( PSTR( MSG_AKTION_PAPER_CHANGED ) );	

};


// ************************************
void GOWritehead_Pos(uint8_t u8Pos )
// ************************************
{
gu8WriteHeadPos = u8Pos;
//@@
//SCHRITMTOR;
};


// ************************************
void BRL_PrIntLFCR(void)
// ************************************
{
GOWritehead_Pos( 0 );
Aktion_PapierVorschub();
};


// ************************************
void BRL_Print_MoveWagon_OneStep(void)
// ************************************
{
if( gu8WriteHeadPos < BRL_PRINTER_LINEPOS_MAX )
	{
	GOWritehead_Pos( gu8WriteHeadPos + 1);
	}
else
	{
	BRL_PrIntLFCR();	
	};
};


// ************************************
void Aktion_PapierVorschub( void )
// ************************************
{
if( gu8LineCnt < BRL_PRINTER_LINES_MAX )
	{
	gu8PrinterStatus_Flags |= PAPIERVORSCHUB;
	gu8Printer_Event_Flags |= NEW_LINE_EVENT;
	gu8LineCnt++;
	gu8PrinterStatus_Flags &= ~PAPERLINES_FULL;	

uart_puts_p(  PSTR( MSG_NEW_LINE ) );
//@@
_delay_ms( PAPIERVORSCHUB_ZEIT );
//SCHRITMOTOR 

	gu8PrinterStatus_Flags &= ~PAPIERVORSCHUB; //NEW_LINE_EVENT bleibt
	}
else
	{
	gu8PrinterStatus_Flags |= PAPERLINES_FULL | Printer_STOP;
	
//STEPPMOTORAKTION
	uart_puts_p(  PSTR( MSG_PAPERCHANGE ) );
	Aktion_Wait_ToPaperChange();
	};
};


// ************************************
uint8_t Check_PrintLines_Available(void )
// ************************************
{
if(gu8LineCnt < BRL_PRINTER_LINES_MAX)
	{
	return BRL_PRINTER_LINES_MAX - gu8LineCnt;
	};
//else
Aktion_PapierVorschub();
return 0;
};


// ************************************
void BRL_PrintChar(uint8_t u8Char)
// ************************************
{
if( u8Char ) // != 0
	{
	GOWritehead_Pos( gu8WriteHeadPos++ );
	CLR_BRAILLE_LED();
	SET_BRAILLE_LED( u8Char );

	};
};


// ************************************
void Trigger_BRL_Printer(void)
// ************************************
{
int i16Zeichen;
if( (i16Zeichen = RingBuf_ReadC(&gsBrailleStrBuf)) != RING_NO_DATA ) 
	{						
	LCD_L2_StrDebug( gcaNumStr );
Toggle_Bit(3);	
		BRL_Print_One( i16Zeichen );
uart_puts_p( PSTR("\n\r BRL_Bits:") );
uart_puts( ByteToBin( i16Zeichen ) );	
	};//				
};


// ************************************
void BRL_Print_One(uint8_t u8Char )
// ************************************
{
//Toggle_Bit( 3);
gu8ActualPrinterBrailleChar =  u8Char;
if( Check_PrintLines_Available() )
	{
	if( gu8WriteHeadPos <  BRL_PRINTER_LINEPOS_MAX )
		{		
		BRL_PrintChar( u8Char );
		}
	else // 0 gelesen
		{
		BRL_PrIntLFCR();	//neue Zeile
		BRL_PrintChar( u8Char );
		};
	};
};



	
