

/*
Christof Ermer
Regensburg
ChristofErmer@gmail.com
06.06.201
*/

#ifndef MY_RING_BUFFER_H
	#define MY_RING_BUFFER_H


#if (__GNUC__ * 100 + __GNUC_MINOR__) < 304
#error "This library requires AVR-GCC 3.4 or later, update to newer AVR-GCC compiler !"
#endif

//Set on this Place Buffesize
// Normaly <= 256 is enough
//BUF_STRMAX never >256,  or change the Datatype from  HEAD & TAIL to "unsigned int". 

//RingBuf_Init( &gsCodesetStrBuf, gu8aCodeSetSrtr, GRSSE );
//Bsp RingBuf_Flush( &gsCodesetStrBuf );
//Returnvalues STR_BUF Read/write Functions, to check the state

/*
// DAS GEHT SO NICHT weil keine #define Konstatte
#if( ( RINGBUFF_SIZE) >= (RAMEND-0x60 ) )
	#error "size of RINGBUFF_SIZE larger than size of SRAM"
#endif

#if( ( RINGBUFF_SIZE - 1)  RINGBUFF_SIZE )
	#error RX buffer size is not a power of 2
#endif
*/

#include <stdint.h>

#define RING_NO_DATA			0x0100
#define RING_OVL				0x0200
#define RING_OVERRUN_ERROR		0x0400
#define RING_OK					0x0800

#define OVL_CHECK_USED
//#define RINGBUF_TEST_USED




//#define RINGBUFF_SIZE 64

//#define BIT8_RINGBUF_USED
#define BIT16_RINGBUF_USED
// *********************************
typedef struct
// **************gcaStr*******************
{
#ifdef BIT8_RINGBUF_USED   //else 16Bit
uint8_t uxHead;
uint8_t uxTail;
uint8_t uxRingBufMask;
#endif
#ifdef BIT16_RINGBUF_USED
uint16_t uxHead;
uint16_t uxTail;
uint16_t uxRingBufMask;
#endif
uint8_t * pau8RingBuf;	// Pointer auf malloc Space
}RINGBUF_TYPE;


extern void RingBuf_Init(RINGBUF_TYPE * pRBuf, uint8_t * pu8BufferStr, uint16_t uxArraySize); // Immer N^2
extern void RingBuf_Flush(RINGBUF_TYPE * pRBuf);
extern void RingBuf_WriteC(RINGBUF_TYPE * pRBuf, uint8_t u8Rx);  //Rckgabeflag: Ok--> 0
extern int RingBuf_ReadC(RINGBUF_TYPE * pRBuf );
extern int RingBuf_Check_Overload(RINGBUF_TYPE * pRBuf); /* Overload State? RingBuf ? */

#ifdef BIT8_RINGBUF_USED
extern uint8_t RingBuf_Bytes_Available(RINGBUF_TYPE * pRBuf); /* Bytes im RingBuf ? */
#endif
#ifdef BIT16_RINGBUF_USED
extern uint16_t RingBuf_Bytes_Available(RINGBUF_TYPE * pRBuf); /* Bytes im RingBuf ? */
#endif

#ifdef RINGBUF_TEST_USED
extern char * CopyRingbufToStr(RINGBUF_TYPE * pRBuf, char * pcStr, uint8_t u8Cnt);  //Monitoring Content  //Monitoring Content;
#endif


#endif // MY_RING_BUFFER_H