

#include <avr\sfr_defs.h>
#include <avr\io.h>
#include <util\delay.h>
#include <stdlib.h>
#include <stdint.h> 
#include <string.h>
#include "debug.h"

#ifdef DEBUG_PRINT_USED
	#include "uart328_16.h"
// *********************************************
void DebugPrint( char* pStr, uint8_t uiNN )
// *********************************************
{
uint8_t uiZZ;
uart_putc(13);
for(uiZZ=0; uiZZ < uiNN; uiZZ++)
	{
	uart_putc( *(pStr + uiZZ) );
	};
uart_putc(13);
uart_putc(13);
}
#endif


//Umkopierer mit 0
#ifdef LCD_LINES_USED
char gcaLCD_L1[ LCD_LINE_CHARS +1];
char gcaLCD_L2[ LCD_LINE_CHARS +1];
//ultoa( u32MainloopCnt, gcaStr, 10 );
// *********************************************
void LCD_L1_int_Debug(int iVal)
// *********************************************
{
itoa( iVal, gcaLCD_L1, 10 );
gcaLCD_L1[ LCD_LINE_CHARS] = 0;//SAVE
};

void LCD_L2_int_Debug(int iVal)
// *********************************************
{
itoa( iVal, gcaLCD_L2, 10 );
gcaLCD_L2[ LCD_LINE_CHARS ] = 0;//SAVE
};

// *********************************************
void LCD_L1_StrDebug( char* pcStr)
// *********************************************
{
uint8_t u8NN;
for(u8NN=0; u8NN< LCD_LINE_CHARS; u8NN++)
	{
	gcaLCD_L1[u8NN]= *(pcStr + u8NN);
	};
gcaLCD_L1[u8NN] = 0;
};

// *********************************************
void LCD_L2_StrDebug( char* pcStr)
// *********************************************
{
uint8_t u8NN;
for(u8NN=0; u8NN< LCD_LINE_CHARS; u8NN++)
	{
	gcaLCD_L2[u8NN]= *(pcStr + u8NN);
	};
gcaLCD_L2[u8NN] = 0;
};
#endif //LCD


#ifdef TOGGLE_FLAG_USED
// mit Oszilloscope Testpin am Controller an geeigneter Stelle watchen.
// Zahl der Toggles gibt Position an. 
// ****************************************************************
void Toggle_Bit(uint8_t u8Cnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
//cli();
//unsigned char u8NN;
TOGGLE_DIRREG |= (1 << TOGGLE_BIT);
while(u8Cnt--)
	{
	TOGGLE_PORT |= (1 << TOGGLE_BIT);
	_delay_us(1);
//	for(u8NN=10;u8NN;u8NN--){}; // 10 =250NS
	TOGGLE_PORT &= ~(1 << TOGGLE_BIT);
	//for(u8NN=10;u8NN;u8NN--){};
	_delay_us(1);
	};
};
#endif


#ifdef N_BYTE_TO_STR_USED
// **********************************************
char * BYTES20_ToDecStr(uint8_t* pStr)
// **********************************************
{
uint8_t u8NN;
char caNumStr[10];
static char caDecStr[WATCHED_DEC_BYTES *5 +1];
*caDecStr=0; //clear
for( u8NN=0; u8NN < WATCHED_DEC_BYTES; u8NN++ )
	{
	strcat( (char*)caDecStr, itoa( *(pStr + u8NN), caNumStr,10) );
	strcat( (char*)caDecStr, ", " );
	};
return caDecStr;
};
#endif


//Byte Anzeige in Binaerer Form
#ifdef BYTE_TO_BIN_USED
// ******************************
char * ByteToBin(uint8_t u8Byte)
// ******************************
{
static char ucBin[9]; //groesse 8+1
char * pcParser = ucBin;
uint8_t u8NN=7;
do
{
if( u8Byte & (1 << u8NN) )
	{
	*pcParser = '1';
	}
else
	{
	*pcParser = '0';
	};
pcParser++;
}while(u8NN--);
ucBin[8]=0; //Terminierung
return  ucBin;
};
#endif
 

//WORD Anzeige in Binaerer Form
#ifdef WORD_TO_BIN_USED
// *******************************************************************
char * WordToBin(uint16_t u16Word)
// *******************************************************************
{
static char ucBin[18]; // Array  zeigt Lcke 0000 0000
char * pcParser = ucBin;
uint8_t u8NN=15;

do
{
if(u8NN == 7)
	{*pcParser =' '; pcParser++;}; // Fge Lcke ein im BYTE
if(u16Word & (1<<u8NN) )
	{
	*pcParser = '1';
	}
else
	{
	*pcParser = '0';
	};
pcParser++;
}while(u8NN--);
ucBin[17]=0;
return  ucBin;
};
#endif



