

/* Programmed by Christof Ermer 10.10.2014 */

#ifndef MAX7219_HEADER
#define  MAX7219_HEADER


/*
*********************************************************************************************************
* Module     : MAX7219.H
* Author     : Randy Rasa
* Description: Header file for MAX7219.C (LED Display Driver Routines)
*********************************************************************************************************
*/

/*
*********************************************************************************************************
* Constants
*********************************************************************************************************
*/
#define REG_DECODE        0x09                        // "decode mode" register
#define REG_INTENSITY     0x0A                        // "intensity" register
#define REG_SCAN_LIMIT    0x0B                        // "scan limit" register
#define REG_SHUTDOWN      0x0C                        // "shutdown" register
#define REG_DISPLAY_TEST  0x0F                        // "display test" register

#define INTENSITY_MIN     0x00                        // minimum display intensity
#define INTENSITY_MAX     0x0F  




//#define MAX7219_FULL_DIRREG		DDRB 
#define MAX7219_DIN_DIRREG		DDRB
#define MAX7219_LOAD_CS_DIRREG	DDRB 
#define MAX7219_CLK_DIRREG		DDRB

#define MAX7219_DIN_PORT		PORTB 
#define MAX7219_LOAD_CS_PORT	PORTB 
#define MAX7219_CLK_PORT		PORTB 

#define MAX7219_DIN		2	 // Anpassen an Hardware
#define MAX7219_LOAD_CS	1			
#define MAX7219_CLK		0	// SCK
//#define MAX7219_DOUT	3	//

/*
*********************************************************************************************************
* Macros
*********************************************************************************************************
*/


//Nur wenn alle Drei bit auf selben Port
#define INIT_MAX7219_DIR()	( MAX7219_FULL_DIRREG |= (1 << MAX7219_DIN) | (1 << MAX7219_LOAD_CS) | (1 << MAX7219_CLK) )

#define SET_MAX7219_DIN()  ( MAX7219_DIN_PORT |= (1 << MAX7219_DIN) )
#define CLR_MAX7219_DIN()  ( MAX7219_DIN_PORT &= ~(1 << MAX7219_DIN) )

#define SET_MAX7219_LOAD_CS()  ( MAX7219_LOAD_CS_PORT |= (1 << MAX7219_LOAD_CS) )
#define CLR_MAX7219_LOAD_CS()  ( MAX7219_LOAD_CS_PORT &= ~(1 << MAX7219_LOAD_CS) )

#define SET_MAX7219_CLK()  ( MAX7219_CLK_PORT |= (1 << MAX7219_CLK) )
#define CLR_MAX7219_CLK()  ( MAX7219_CLK_PORT &= ~(1 << MAX7219_CLK) )

/*
*********************************************************************************************************
* Public Function Prototypes
*********************************************************************************************************
*/

// DATA ROW <8,<256
extern void MAX7219_Write( unsigned char u8Register, unsigned char u8Data);
extern void MAX7219_Init(void);
extern void MAX7219_Clear (void);
extern void MAX7219_SetBrightness (char brightness)
;
#endif //MAX7219_HEADER